<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement Systempay
#						Version : 2.6 (rvision 21960)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.1.4
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						21/12/2010
#						Contact : supportvad@lyra-network.com
#
#####################################################################################################

class ps_vads {

	var $payment_code = "VADS";
	var $classname = "ps_vads";
	var $lang;
	
	/* ********************* *
	 * ADMIN PARAMETERS FORM *
	 * ********************* */
	/**
     * Show all configuration parameters for this payment method
     *
     * @returns boolean False when the Payment method has no configration
     */
	function show_configuration()
	{
		$this->lang =& new ps_VADS_LANG();
		$db =& new ps_DB;
		
		// Read current configuration
		require_once(CLASSPATH . "payment/" . $this->classname . ".cfg.php" );

		echo '<table>';
        echo ' <tr><td colspan="3"><img src="'.URL.'images/Systempay.jpg" alt="Systempay" /></td></tr>';
		
		/*
		 * Author
		 */
        echo $this->_write_title_config_line('VADS_INFO_TITLE');
		echo $this->_write_config_line('VADS_AUTHOR', '<a href="http://www.lyra-network.com">Lyra-network</a>', 'VADS_SUPPORT');
		$code = '2.6 ' . $this->lang->_('VADS_CMS_VERSION') . ' 1.1.4';
		echo $this->_write_config_line('VADS_VERSION', $code, 'VADS_GATEWAY_VERSION');
		
		/*
		 * Payment gateway login
		 */
		echo $this->_write_title_config_line('VADS_GATEWAY_TITLE');
		// site_id
		echo $this->_write_simple_config_line('VADS_SITE_ID');
		// certificate
		echo $this->_write_simple_config_line('VADS_KEY_TEST');
		echo $this->_write_simple_config_line('VADS_KEY_PROD');
		//mode
		$test_text = (VADS_MODE=='TEST' || VADS_MODE=='') ? ' selected="selected"' : '';
		$prod_text = (VADS_MODE=='PRODUCTION') ? ' selected="selected"' : '';
		$code = '<select name="VADS_MODE" class="inputbox">
					<option value="TEST"'.$test_text.'>'.$this->lang->_('VADS_MODE_TEST').'</option>
					<option value="PRODUCTION"'.$prod_text.'>'.$this->lang->_('VADS_MODE_PRODUCTION').'</option>
				</select>';
		echo $this->_write_config_line('VADS_MODE', $code,'VADS_MODE_INFO');
		// payment page
		echo $this->_write_simple_config_line('VADS_LIEN_BANQUE');
		
		/*
		 * Payment settings
		 */
		echo $this->_write_title_config_line('VADS_PAYMENT_TITLE');
		// currency
		echo $this->_write_simple_config_line('VADS_MONNAIE');
		
		// languages
		$language_codes = array('de','es','en','fr','it','ja','zh');
		foreach($language_codes as $lang) {
			$languages[$lang] = $this->lang->_('VADS_LANGAGE_DEFAUT_'.strtoupper($lang));
		}
		asort($languages);
		$code = '<select name="VADS_LANGAGE_DEFAUT" size="4" class="inputbox">';
		foreach($languages as $lang => $label) {
			$selected = (VADS_LANGAGE_DEFAUT==$lang) ? ' selected="selected"' : '';
			$code .= '<option value="'.$lang.'"'.$selected.'>'.$label.'</option>';
		}
		$code .= '</select>';
		echo $this->_write_config_line('VADS_LANGAGE_DEFAUT', $code,'VADS_LANGAGE_DEFAUT_INFO');
		
		// delay
		echo $this->_write_simple_config_line('VADS_DELAY');
		
		// validation mode
		$code = '<select name="VADS_TYPE_VALIDATION" class="inputbox">
					<option value=""'.(!VADS_TYPE_VALIDATION ? ' selected="selected"' : '').'>'.$this->lang->_('VADS_TYPE_VALIDATION_DEFAULT').'</option>
					<option value="0"'.(VADS_TYPE_VALIDATION=='0' ? ' selected="selected"' : '').'>'.$this->lang->_('VADS_TYPE_VALIDATION_AUTOMATIQUE').'</option>
					<option value="1"'.(VADS_TYPE_VALIDATION=='1' ? ' selected="selected"' : '').'>'.$this->lang->_('VADS_TYPE_VALIDATION_MANUELLE').'</option>
				</select>';
		echo $this->_write_config_line('VADS_TYPE_VALIDATION', $code,'VADS_TYPE_VALIDATION_INFO');
		
		// payment cards
		$code = '<select name="CARTE[]" size="4" multiple class="inputbox">';
		$selected_cards = explode(';',VADS_CARTE_DISPO);
		$available_cards = array('','AMEX','CB','MASTERCARD','VISA');
		foreach($available_cards as $card) {
			$label = ($card=='') ? $this->lang->_('VADS_CARTE_DISPO_TOUS') : $this->lang->_('VADS_CARTE_DISPO_'.$card);
			$selected = in_array($card, $selected_cards) ? ' selected="selected"' : '';
			$code .= '<option value="'.$card.'"'.$selected.'>'.$label.'</option>';
		}
		$code .= '</select>';
		echo $this->_write_config_line('VADS_CARTE_DISPO', $code,'VADS_CARTE_DISPO_INFO');
		
		/*
		 * Return parameters
		 */
		echo $this->_write_title_config_line('VADS_RETURN_TITLE');
		echo $this->_write_simple_config_line('VADS_URL_DEFAUT');
		
		$code  = '<select name="VADS_RETURN_MODE" class="inputbox">';
		$code .= '	<option value="GET"'.(VADS_RETURN_MODE=='GET' ? ' selected="selected"' : '').'>'.$this->lang->_('VADS_RETURN_MODE_GET').'</option>';
		$code .= '	<option value="POST"'.(VADS_RETURN_MODE=='POST' ? ' selected="selected"' : '').'>'.$this->lang->_('VADS_RETURN_MODE_POST').'</option>';
//		$code .= '	<option value="NONE"'.(VADS_RETURN_MODE=='NONE' ? ' selected="selected"' : '').'>'.$this->lang->_('VADS_RETURN_MODE_NONE').'</option>';
		$code .= '</select>';
		echo $this->_write_config_line('VADS_RETURN_MODE', $code, 'VADS_RETURN_MODE_INFO');
		
		$selected_false = (VADS_REDIRECT_ENABLED == 'False' || !VADS_REDIRECT_ENABLED);
		$code = '<select name="VADS_REDIRECT_ENABLED" class="inputbox">
					<option value="False"'.($selected_false ? ' selected="selected"' : '').'>'.$this->lang->_('VADS_DISABLED').'</option>
					<option value="True"'.($selected_false ? '' : ' selected="selected"').'>'.$this->lang->_('VADS_ENABLED').'</option>
				</select>';
		echo $this->_write_config_line('VADS_REDIRECT_ENABLED', $code,'VADS_REDIRECT_ENABLED_INFO');
		
		echo $this->_write_simple_config_line('VADS_REDIRECT_SUCCESS_TIMEOUT');
		echo $this->_write_simple_config_line('VADS_REDIRECT_SUCCESS_MESSAGE');
		echo $this->_write_simple_config_line('VADS_REDIRECT_ERROR_TIMEOUT');
		echo $this->_write_simple_config_line('VADS_REDIRECT_ERROR_MESSAGE');
		
		/*
		 * Status of orders treated with this payment method
		 */
		// successful orders
		$order_statuses = "";
		$db->query("SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order");
		while ($db->next_record() ) {
			$order_statuses[$db->f("order_status_code" )] = $db->f("order_status_name" );
		}
		
		$code = '<select name="VADS_VERIFIED_STATUS" class="inputbox" >';
		foreach($order_statuses as $order_status_code => $order_status_name) {
			$code .= "<option value=\"" . $order_status_code.'"';
			$code .= (VADS_VERIFIED_STATUS == $order_status_code) ? ' selected="selected">' : '>';
			$code .= $order_status_name . "</option>\n";
		}
		$code .= '</select>';
		echo $this->_write_config_line('PS_VADS_ORDER_OK', $code,'PS_VADS_ORDER_OK_INFO');
		
		// invalid orders
		$code = '<select name="VADS_INVALID_STATUS" class="inputbox" >';
		foreach($order_statuses as $order_status_code => $order_status_name) {
			$code .= "<option value=\"" . $order_status_code.'"';
			$code .= (VADS_INVALID_STATUS == $order_status_code) ? ' selected="selected">' : '>';
			$code .= $order_status_name . "</option>\n";
		}
		$code .= '</select>';
		echo $this->_write_config_line('PS_VADS_ORDER_KO', $code,'PS_VADS_ORDER_KO_INFO');
		
		/*
		 * Extra information
		 */
		echo $this->_write_title_config_line('VADS_EXTRA_TITLE');
		echo $this->_write_config_line('PS_VADS_URL_SILENCIEUSE', URL.'index.php?page=checkout.vads_rsts&amp;option=com_virtuemart','PS_VADS_URL_SILENCIEUSE_INFO');
		echo $this->_write_config_line('PS_VADS_EXTRA_CODE', htmlentities('<?php require_once(PAGEPATH."checkout.vads_cc_form.php") ; ?>'),'PS_VADS_EXTRA_CODE_INFO');
		
		echo '</table>';
		return true;
	}
	
	function _write_title_config_line($title_code) {
		return '<tr><td colspan="3" style="font-weight:bold;background-color:#D2D2D2;">'.$this->lang->_($title_code).'</td></tr>';
	}
	
	/**
	 *
	 * Builds and returns html code for an administration text parameter
	 * @param $param_name
	 */
	function _write_simple_config_line($param_name) {
		$label_name = $param_name;
		$input_code = '<input type="text" name="'.$param_name.'" class="inputbox" value="'.constant($param_name).'" />';
		$desc_name = $param_name.'_INFO';
		return $this->_write_config_line($label_name, $input_code, $desc_name);
	}
	
	/**
	 *
	 * Builds and returns html code for an administration parameter
	 * @param $label_name
	 * @param $input_code
	 * @param $desc_name
	 */
	function _write_config_line($label_name,$input_code,$desc_name) {
		static $cpt=0;
		$cpt++;
		$color = ($cpt%2 == 1) ? ' bgcolor="#e4e4e4"' : '';
		return '<tr'.$color.'><td>'.$this->lang->_($label_name).'</td><td>'.$input_code.'</td><td>'.$this->lang->_($desc_name).'<td></tr>';
	}
	
	/**
	 *
	 * Build payment_cards string from array
	 * @param $p
	 */
	function getCarte($p){
		if(count($p)>0){
			$r='';
			foreach($p as $val){
				if($r!='')
					$r.=';';
					
				$r.=$val;
			}
			return $r;
		}
		else
			return '';
	}
	
	
	/* *************************** *
	 * VIRTUEMART CONFIG FUNCTIONS *
	 * *************************** */
	function has_configuration() { return true; }
	
	function configfile_writeable() {
		return is_writeable(CLASSPATH . "payment/" . $this->classname . ".cfg.php" );
	}

	
	function configfile_readable() {
		return is_readable(CLASSPATH . "payment/" . $this->classname . ".cfg.php" );
	}
	
	/**
    * Writes the configuration file for this payment method
    *
    * @param array $d An array of objects
    * @returns boolean True when writing was successful
    */
	function write_configuration(&$d )
	{
		$config  = "<?php # FILE GENERATED BY ps_vads.php : ".date('d-m-Y H:i:s ');
		$config .= <<<ENDOFHEADER
#####################################################################################################
#
#					Module pour la plateforme de paiement Systempay
#						Version : 2.6 (rvision 21960)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.1.4
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						21/12/2010
#						Contact : supportvad@lyra-network.com
#
#####################################################################################################

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
ENDOFHEADER;
		$config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";

		$config_params = array(
			'VADS_SITE_ID' => '12345678',
			'VADS_LIEN_BANQUE' => 'https://systempay.cyberpluspaiement.com/vads-payment/',
			'VADS_MODE' => 'TEST',
			'VADS_DELAY' => '',
			'VADS_MONNAIE' => '978',
			'VADS_LANGAGE_DEFAUT' => 'fr',
			'VADS_CARTE_DISPO' => $this->getCarte($d['CARTE']),
			'VADS_TYPE_PAIEMENT' => 'SINGLE',
			'VADS_TYPE_VALIDATION' => '',
			'VADS_URL_DEFAUT' => URL.'index.php?page=checkout.vads_response&option=com_virtuemart',
			'VADS_RETURN_MODE' => 'GET',
			'VADS_KEY_TEST' => '1111111111111111',
			'VADS_KEY_PROD' => '2222222222222222',
			'VADS_VERIFIED_STATUS' => 'C',
			'VADS_INVALID_STATUS' => 'P',
			'VADS_REDIRECT_ENABLED' => 'False',
			'VADS_REDIRECT_SUCCESS_TIMEOUT' => '5',
			'VADS_REDIRECT_SUCCESS_MESSAGE' => 'Redirection vers la boutique dans quelques instants',
			'VADS_REDIRECT_ERROR_TIMEOUT' => '5',
			'VADS_REDIRECT_ERROR_MESSAGE' => 'Redirection vers la boutique dans quelques instants'
		);
		foreach($config_params as $key => $default ) {
			if (!array_key_exists($key,$d))
				$value = $default;
			else
				$value = $d[$key];
			$value = mysql_escape_string($value);	// avoid problems with value containing '
			$config .= "\ndefine ('$key', '$value');";
		}

		$config .= "?>";

		if ($fp = fopen(CLASSPATH . "payment/" . $this->classname . ".cfg.php", "w" ) ) {
			fputs($fp, $config, strlen($config ) );
			fclose ($fp );
		} else {
			$this->lang = new ps_VADS_LANG();
			$d["error"] = $this->lang->_('PS_VADS_CONFIG_ERROR') . CLASSPATH . "payment/" . $this->classname . ".cfg.php";
			return false;
		}

		return true;
	}


	/**
     *
     */
	function process_payment($order_number, $order_total, &$d )	{
		return true;
	}
	
	/**
	 * Function used in response processing pages. Updates an order status with payment result data
	 */
	function update_order($vads_api, $status) {
		$d = array();
		$d['order_id'] = $vads_api->get('order_id');
		$d['order_status'] = $status;
		$d['notify_customer'] = "N";
		$d['include_comment'] = "Y";
		$d['order_comment'] = htmlentities($vads_api->getResponseMessage('detail'), ENT_QUOTES)
			.($vads_api->getReponse3DSec()!='' ? '<br/>'.htmlentities($vads_api->getReponse3DSec(), ENT_QUOTES) : "");
		$ps_order = new ps_order;
		$ps_order->order_status_update($d);
	}
}



class ps_VADS_LANG extends vmAbstractLanguage {
	// Override basic language class with french as default language
	function ps_VADS_LANG() {
		global $mosConfig_lang;

		if (file_exists( ADMINPATH. 'languages/vads/'.$mosConfig_lang.'.php' )) {
			require_once( ADMINPATH. 'languages/vads/'.$mosConfig_lang.'.php' );

		} else if (file_exists( ADMINPATH. 'languages/vads/french.php' )) {
			require_once( ADMINPATH. 'languages/vads/french.php' );
		}
		$this->setDebug();
		$this->initModule( 'vads', $langvars );
	}
}




/**
 * Classe implmentant la gnration de formulaire et la vrification de signature
 *
 */
class VADS_API
{
	//TODO il manque certains paramtres facultatifs (user_info, order_info2/3, theme_config...)
	
	/* ********* *
	 * ATTRIBUTS *
	 * ********* */
	/* PARAMETRES D'ENVOI OBLIGATOIRES */
	var $version='V1';		// Version de la plateforme de paiement
	var $currency='978';	// Monnaie  utiliser selon norme ISO 4217 (http://www.iso.org/iso/support/currency_codes_list-1.htm)
	var $payment_cards='';	// Liste des types de cartes pouvant tre utilises pour le paiement
							// vide = tout type accept, sinon une combinaison des codes suivants spars par ";" : AMEX;CB;MASTERCARD;VISA

	var $amount; 			// Montant de la trasaction (en cents)
	var $capture_delay; 	// Dlais en jour avant remis en banque (si vide, paramtre par dfaut dfini dans le back office)
	var $ctx_mode;			// Mode de solicitation de la plateforme (TEST ou PRODUCTION)
	
	var $payment_config; 	// Type de paiement (SINGLE ou MULTI)
							/*Exemple pour un paiement de 10000 cents (100 euros) :
							 payment_config=SINGLE (en une fois)
							 ou
							 payment_config=MULTI:first=5000;count=3;period=30 (en plusieurs fois)
							 (Premier paiement de 5000 cents aujourd'hui + "capture_delay"
							 Deuxime paiement de 2500 cents  aujourd'hui + "capture_delay"+ 30 jours
							 Troisime paiement de 2500 cents  aujourd'hui + "capture_delay" + 60 jours)*/
	var $signature;			// Utilise pour authentifier les changes avec la plateforme (cf. calculSignature() )
	var $site_id;			// Disponible dans le back office de la plateforme de paiement
	var $trans_date;		// Date locale du site (format : AAAAMMJJHHMMSS)
	var $trans_id;			// Constitu de 6 caractres numriques, unique pour le site et pour la journe entire (cf. function calculTransId() )
	var $validation_mode;	// Si validation manuelle du commerant. Par dfaut paramtre dfini dans le backoffice

	var $platform_url;	// Url de la plateforme de paiement

	var $key_test;			// Cl fournie par la plateforme servant  calculer la signature
	var $key_prod;			// idem en mode production

	/* PARAMETRES D'ENVOI FACULTATIFS */
	var $cust_id;			// Identifiant client pour le marchand
	var $cust_name;			// Nom du client
	var $cust_title;		// Civilit du client
	var $cust_email;		// Adresse e-mail du client (envoi d'un mail rcapitulatif de la transaction)
	var $cust_address;		// Adresse du client
	var $cust_zip;			// Code postal du client
	var $cust_city;			// Ville du client
	var $cust_phone;		// Numro de tlphone du client
	var $cust_country;		// Pays du client (Norme ISO 3166 http://www.iso.org/iso/fr/country_codes/iso_3166_code_lists/english_country_names_and_code_elements.htm)
	var $language;			// Langue de la page de paiement Norme ISO 639-1 (par dfaut le franais est slectionn)
							//valeurs possibles : fr (dfaut), de, en, zh, es, fr, it, ja
	var $order_id;			// Numro de commande (rappel dans l'e-mail de confirmation du client), 32 caractres alpha-numriques maximum
	var $order_info;		// Rsum de la commande
	var $url_return;		// Url par dfaut (aprs appui du bouton "retourner  la boutique" par le client sur la plateforme)
	var $url_success;		// Url en cas de succs du paiement (aprs appui du bouton "retourner  la boutique")
	var $url_referral;		// Url en cas de refus d'autorisation, code 02 "referral" (aprs appui du bouton "retourner  la boutique")
	var $url_refused;		// Url en cas de refus autre que "referral" (aprs appui du bouton "retourner  la boutique")
	var $url_cancel;		// Url en cas d'annulation par le client (aprs appui sur "annuler et retourner sur la boutique")
	var $url_error;			// Url en cas d'erreur interne
	var $url_check;			// Url appele par la plateforme de paiement pour confirmer le paiement
							// Pour une scurit optimale, ne pas utiliser ce paramtre. Le configurer dans le backoffice de la plateforme
	var $contrib='VirtueMart1.1.4_2.6';	// code identifiant le plugin de paiement (par ex. "thelia_v2.0")
	var $redirect_enabled;	// Activer ou non la redirection automatique du client vers la boutique
	var $redirect_success_timeout;	// si $redirect_enabled, dfinit le temps en secondes (0-300) avant la redirection automatique
	var $redirect_success_message;	// si $redirect_enabled, dfinit le message affich avant la redirection automatique
	var $redirect_error_timeout;	// si $redirect_enabled, dfinit le temps avant redirection automatique, lorsque le paiement a chou
	var $redirect_error_message;	// si $redirect_enabled, dfinit le message affich avant redirection automatique, lorsque le paiement a chou
	var $return_mode;		// POST (dfaut), GET ou NONE : faon dont les paramtres seront transmis lorsque le client clique sur "retour  la boutique"


	/* PARAMETRES DE REPONSE DE LA PLATEFORME */
	var $auth_result;		// Code retour de la demande d'autorisation retourne par la banque mettrice, si disponible (vide sinon).
	var $auth_mode;			// Indique comment a t ralise la demande dautorisation. Ce champ peut prendre les valeurs suivantes :
							#- FULL : correspond  une autorisation du montant total de la transaction dans le cas dun paiement unitaire avec remise  moins de 6 jours,
							# 		ou  une autorisation du montant du premier paiement dans le cas du paiement en N fois, dans le cas dune remise de ce premier paiement  moins de 6 jours.
							#- MARK : correspond  une prise dempreinte de la carte, dans le cas ou le paiement est envoy en banque  plus de 6 jours.
	var $auth_number;		// Numro d'autorisation retourn par le serveur bancaire, si disponible (vide sinon).
	var $card_brand;		// Type de carte utilis pour le paiement, si disponible (vide sinon).
	var $card_number;		// Numro de carte masqu.
	var $extra_result;		// Code complmentaire de rponse. Sa signification dpend de la valeur renseigne dans result.
							# Lorsque result vaut 30 (erreur de requte), alors extra_result contient un code indiquant quel champ a t mal rempli
	var $warranty_result;	// Si lautorisation a t ralise avec succs, indique la garantie du paiement, lie  3D-Secure :
							# YES => Le paiement est garanti
							# NO => Le paiement nest pas garanti
							# UNKNOWN => Suite  une erreur technique, le paiement ne peut pas tre garanti
							# Non valoris => Garantie de paiement non applicable
	var $payment_certificate;// Si lautorisation a t ralise avec succs, la plateforme de paiement dlivre un certificat de paiement. Pour toute question concernant un paiement ralis sur la plateforme, cette information devra tre communique.
	var $result;			// Code retour.
							#- 00 : Paiement ralis avec succs.
							#- 02 : Le commerant doit contacter la banque du porteur.
							#- 05 : Paiement refus.
							#- 17 : Annulation client.
							#- 30 : Erreur de format de la requte. A mettre en rapport avec la valorisation du champ extra_result.
							#- 96 : Erreur technique lors du paiement.
	var $hash;				// Valeur retour de serveur  serveur permettant de calculer la signature de retour
	
	var $received_signature;// Signature reue en POST au retour de la plateforme

	
	/* VARIABLES LIEES L'OBJET */
	var $timestamp='';		//Timestamp lors de la cration du formulaire

	var $tab_auth_result;	// Tableau de rponses de confirmation (code => traduction)
	var $tab_warranty_result;// Tableau de rponses 3D Secure
	var $tab_result;		// Tableau de rponses globales
	var $tab_extra_result;	// Tableau de rponses globales dtailles

	
	/* LISTES DES ATTRIBUTS DE L'OBJET utiles pour les foreach... */
	// lies  la requte (sauf key et signature)
	var $request_mandatory = array(
		'amount','capture_delay','currency','ctx_mode','payment_cards','payment_config','site_id','trans_date','trans_id',
		'validation_mode','version'
	);
	var $request_optionnal = array(
		'cust_id','cust_name','cust_title','cust_address','cust_zip','cust_city','cust_phone','cust_country','language','order_id','order_info',
		'cust_email','url_return','url_success','url_referral','url_refused','url_cancel','url_error','url_check','contrib',
		'redirect_success_timeout','redirect_success_message','redirect_error_timeout','redirect_error_message','return_mode'
	);
	var $request_signature = array(
		'version','site_id','ctx_mode','trans_id','trans_date','validation_mode','capture_delay','payment_config','payment_cards','amount',
		'currency'
	);
	
	// lies  la rponse (sauf key, signature et hash)
	var $response_specific = array(
		'auth_result','auth_mode','auth_number','card_brand','card_number','extra_result','warranty_result','payment_certificate','result'
	);
	var $response_requestlike = array(
		// same as response
		'amount','contrib','ctx_mode','currency','payment_config','site_id','trans_date','trans_id','version','order_id','order_info',
		'cust_address','cust_country','cust_email','cust_id','cust_name','cust_phone','cust_title','cust_city','cust_zip','payment_src',
		// same as response or default
		'capture_delay','validation_mode','language'
	);
	var $response_signature = array(
		'version','site_id','ctx_mode','trans_id','trans_date','validation_mode','capture_delay','payment_config','card_brand','card_number',
		'amount','currency','auth_mode','auth_result','auth_number','warranty_result','payment_certificate','result'
	);
	
	// Autres attributs
	var $misc = array('key_test','key_prod','hash','redirect_enabled','platform_url','signature','received_signature');
	
	
	/* ********************************* *
	 * GETTERS/SETTERS SUR LES VARIABLES *
	 * ********************************* */
	/**
	 * renvoie un tableau contenant les noms des attributs lis  telle ou telle fonction de l'objet
	 */
	function getAttributeList($type=null)
	{
		switch($type)
		{
			case "request_mandatory":
				return $this->request_mandatory;
			case "request_optionnal":
				return $this->request_optionnal;
			case "request_all":
				return array_merge($this->request_mandatory,$this->request_optionnal);
				
			case "response_specific":
				return $this->response_specific;
			case "response_requestlike":
				return $this->response_requestlike;
			case "response_all":
				return array_merge($this->response_specific, $this->response_requestlike);
				
			case "request_signature":
				return $this->request_signature;
			case "response_signature":
				return $this->response_signature;
				
			case "misc":
				return $this->misc;
			case "all":
			default:
				return array_unique(array_merge(
					$this->request_mandatory, $this->request_optionnal, $this->request_signature,
					$this->response_specific, $this->response_requestlike, $this->response_signature,
					$this->misc
				));
		}
	}
	
	/**
	 * renvoie la valeur d'un attribut public
	 */
	function get($name='')
	{
		$result = null;
		if( in_array($name, $this->getAttributeList("all"),true) )
		{
			$result = $this->$name;
		}
		if($name==="key")
		{
			$result = ($this->ctx_mode=="TEST") ? $this->key_test : $this->key_prod;
		}
		return $result;
	}
	
	/**
	 * Renvoie la liste des codes iso des langues supportes par la plateforme de paiement
	 * @return multitype:string
	 */
	function getSupportedLanguages() {
		return array('fr','de','en','es','zh','it','ja','pt');
	}
	
	/**
	 * Rcupration du code numrique ISO 4217 d'une devise  partir de son code  3 lettres.
	 * @param string $alpha3 code alphabtique de la devise (ex:EUR,USD,JPY...)
	 */
	function convertAlphaCurrency($alpha3) {
		$currencies = array (
			"AUD" => "036", //Dollar australien
			"CAD" => "124", //Dollar canadien
			"CNY" => "156", //Renminbi yuan chinois
			"DKK" => "208", //Couronne danoise
			"JPY" => "392", //Yen
			"SEK" => "752", //Couronne sudoise
			"CHF" => "756", //Franc suisse
			"GBP" => "826", //Livre sterling
			"USD" => "840", //Dollar des tats-Unis
            "EUR" => "978"  //Euro            
		);
		if(array_key_exists($alpha3, $currencies)) {
			return $currencies[$alpha3];
		}
		else {
			return false;
		}
	}
	
	/**
	 * Modifie la valeur d'un attribut public
	 * @return boolean true si russite, false sinon
	 */
	function set($name='',$value=null)
	{
		if( in_array($name, $this->getAttributeList("all")) )
		{
			$this->$name = $value;
			return true;
		}
		return false;
	}
	
	/**
	 * Modifie les valeurs d'attributs publics  partir d'un tableau
	 * @param $params tableau de paramtres format nom=>valeur
	 * @return boolean true si toutes les valeurs du tableau ont pu tre enregistres, false si non
	 */
	function setFromArray($params)
	{
		$result = true;
		foreach ($params as $name => $value)
		{
			$temp_result = $this->set($name,$value);
			if( $temp_result == false )
				$result = false;
		}
		return $result;
	}
	
	/* ************ *
	 * CONSTRUCTEUR *
	 * ************ */
	function VADS_API()
	{
		// Intialisation des variables prives
		$this->timestamp=time();
		$this->loadResponsesTranslation();
		$auth_result='';
		$auth_mode='';
		$auth_number='';
		$card_brand='';
		$card_number='';
		$extra_result='';
		$warranty_result='';
		$payment_certificate='';
		$result='';
		$hash='';

		//Calcul
		$this->generateTrans_id();
		$this->getTrans_date();
	}

	/**
	 * Chargement des traductions des codes retour dans tab_result, tab_auth_result et tab_warranty_result
	 */
	function loadResponsesTranslation($lang='fr'){
		$translations = array();
		//NB : translations have to be complete !
		$translations['fr'] = array(
//			'MISSING_RESULT_TRANSLATION' => "Traduction manquante pour le code de retour ",
//			'MISSING_EXTRA_RESULT_TRANSLATION' => "Traduction manquante pour le code de retour complmentaire ",
			
			# warranty_result
			'PAIEMENT_GARANTI' => 'Le paiement est garanti',
			'PAIEMENT_PAS_GARANTI' => 'Le paiement n\'est pas garanti',
			'INCIDENT_TECHNIQUE_PAIEMENT_PAS_GARANTI' => 'Suite  une erreur technique, le paiement ne peut pas tre garanti',
			
			# result
			'PAIEMENT_REALISE_SUCCES' => 'Paiement ralis avec succs',
			'COMMERCANT_CONTACTER_BANQUE_PORTEUR' => 'Le commerant doit contacter la banque du porteur',
			'PAIEMENT_REFUSE' => 'Paiement refus',
			'ANNULATION_CLIENT' => 'Annulation client',
			'ERREUR_FORMAT_REQUETE' => 'Erreur de format de la requte',
			'ERREUR_TECHNIQUE_LORS_PAIEMENT' => 'Erreur technique lors du paiement',
			
			# extra_result
			'VERSION_MODE_PAIEMENT_BPL' => "Version du module de paiement (normalement : 2.6)",
			'ATTRIBUER_LORS_INSCIPTION_COMMERCANT' => "Attribu lors de l'inscription du commerant",
			'UNIQUE_POUR_SITE_POUR_1_JOURNEE' => "Unique pour le site et pour la journe",
			'DATE_LOCALE_SITE' => "Date locale du site",
			'SI_VALIDATION_MANUELLE_COMMERCANT' => "Si validation manuelle du commerant",
			'DELAI_NB_JOUR_REMISE_BANQUE' => "Dlais en jour avant remise en banque",
			'TYPE_PAIEMENT' => "Type de paiement (en une ou plusieurs fois)",
			'LISTE_CARTES_DISPO' => "Liste des types de cartes disponibles",
			'MONTANT_TRANSACTION' => "Montant de la trasaction (en cents)",
			'MONNAIE_UTILISER_ISO' => "Monnaie  utiliser selon norme ISO 4217",
			'MODE_PLATEFORME' => "Mode de solicitation de la plateforme",
			'LANGUE_PAGE_PAIEMENT'=> "Langue de la page de paiement Norme ISO 639-1",
			'NUMERO_COMMANDE' => "Numro de commande",
			'RESUME_COMMANDE' => "Rsum de la commande",
			'ADRESSE_EMAIL_CLIENT' => "Adresse e-mail du client",
			'IDENTIFIANT_CLIENT_POUR_MARCHANT' => "Identifiant client pour le marchand",
			'CIVILITE_CLIENT' => "Civilit du client",
			'NOM_CLIENT' => "Nom du client",
			'ADRESSE_CLIENT' => "Adresse du client",
			'CODE_POSTAL_CLIENT' => "Code postal du client",
			'VILLE_CLIENT' => "Ville du client",
			'PAYS_CLIENT_ISO' => "Pays du client (Norme ISO 3166 )",
			'TELEPHONE_CLIENT' => "Tlphone du client",
			'ERREUR_INCONNUE_DANS_REQUETE' => "Erreur inconnue dans la requte",
			'URL_SUCCESS' => "Url de retour lorsque le paiement est russi",
			'URL_REFUS' => "Url de retour lorsque le paiement est refus",
			'URL_REFUS_AUTORISATION' => "Url de retour lorsque le paiement n'a pas t autoris",
			'URL_ANNULATION' => "Url de retour lorsque le client annule le paiement",
			'URL_DEFAUT' => "Url de retour par dfaut",
			'URL_ERREUR' => "Url de retour en cas d'erreur",
		);
		
		$translation = array_key_exists($lang,$translations) ? $translations[$lang] : $translations['fr'];
		
		
//		$missing_msg = $translation['MISSING_RESULT_TRANSLATION'];

		# warranty_result
		$this->tab_warranty_result['YES'] = $translation['PAIEMENT_GARANTI'];
		$this->tab_warranty_result['NO'] = $translation['PAIEMENT_PAS_GARANTI'];
		$this->tab_warranty_result['UNKNOWN'] = $translation['INCIDENT_TECHNIQUE_PAIEMENT_PAS_GARANTI'];

		# result
		$this->tab_result['00'] = $translation['PAIEMENT_REALISE_SUCCES'];
		$this->tab_result['02'] = $translation['COMMERCANT_CONTACTER_BANQUE_PORTEUR'];
		$this->tab_result['05'] = $translation['PAIEMENT_REFUSE'];
		$this->tab_result['17'] = $translation['ANNULATION_CLIENT'];
		$this->tab_result['30'] = $translation['ERREUR_FORMAT_REQUETE'];
		$this->tab_result['96'] = $translation['ERREUR_TECHNIQUE_LORS_PAIEMENT'];

//		$missing_msg = $translation['MISSING_EXTRA_RESULT_TRANSLATION'];
		# extra_result
		$this->tab_extra_result['01'] = 'version => '.$translation['VERSION_MODE_PAIEMENT_BPL'];
		$this->tab_extra_result['02'] = 'site_id => '.$translation['ATTRIBUER_LORS_INSCIPTION_COMMERCANT'];
		$this->tab_extra_result['03'] = 'trans_id => '.$translation['UNIQUE_POUR_SITE_POUR_1_JOURNEE'];
		$this->tab_extra_result['04'] = 'trans_date => '.$translation['DATE_LOCALE_SITE'];
		$this->tab_extra_result['05'] = 'validation_mode => '.$translation['SI_VALIDATION_MANUELLE_COMMERCANT'];
		$this->tab_extra_result['06'] = 'capture_delay => '.$translation['DELAI_NB_JOUR_REMISE_BANQUE'];
		$this->tab_extra_result['07'] = 'payment_config => '.$translation['TYPE_PAIEMENT'];
		$this->tab_extra_result['08'] = 'payment_cards => '.$translation['LISTE_CARTES_DISPO'];
		$this->tab_extra_result['09'] = 'amount => '.$translation['MONTANT_TRANSACTION'];
		$this->tab_extra_result['10'] = 'currency => '.$translation['MONNAIE_UTILISER_ISO'];
		$this->tab_extra_result['11'] = 'ctx_mode => '.$translation['MODE_PLATEFORME'];
		$this->tab_extra_result['12'] = 'language => '.$translation['LANGUE_PAGE_PAIEMENT'];
		$this->tab_extra_result['13'] = 'order_id => '.$translation['NUMERO_COMMANDE'];
		$this->tab_extra_result['14'] = 'order_info => '.$translation['RESUME_COMMANDE'];
		$this->tab_extra_result['15'] = 'cust_email => '.$translation['ADRESSE_EMAIL_CLIENT'];
		$this->tab_extra_result['16'] = 'cust_id => '.$translation['IDENTIFIANT_CLIENT_POUR_MARCHANT'];
		$this->tab_extra_result['17'] = 'cust_title => '.$translation['CIVILITE_CLIENT'];
		$this->tab_extra_result['18'] = 'cust_name => '.$translation['NOM_CLIENT'];
		$this->tab_extra_result['19'] = 'cust_address => '.$translation['ADRESSE_CLIENT'];
		$this->tab_extra_result['20'] = 'cust_zip => '.$translation['CODE_POSTAL_CLIENT'];
		$this->tab_extra_result['21'] = 'cust_city => '.$translation['VILLE_CLIENT'];
		$this->tab_extra_result['22'] = 'cust_country => '.$translation['PAYS_CLIENT_ISO'];
		$this->tab_extra_result['23'] = 'cust_phone => '.$translation['TELEPHONE_CLIENT'];
		$this->tab_extra_result['24'] = 'url_success => '.$translation['URL_SUCCESS'];
		$this->tab_extra_result['25'] = 'url_refused => '.$translation['URL_REFUS'];
		$this->tab_extra_result['26'] = 'url_referral => '.$translation['URL_REFUS_AUTORISATION'];
		$this->tab_extra_result['27'] = 'url_cancel => '.$translation['URL_ANNULATION'];
		$this->tab_extra_result['28'] = 'url_return => '.$translation['URL_DEFAUT'];
		$this->tab_extra_result['29'] = 'url_error => '.$translation['URL_ERREUR'];
		$this->tab_extra_result['99'] = $translation['ERREUR_INCONNUE_DANS_REQUETE'];
	}

	/* ******************* *
	 * CALCUL DE SIGNATURE *
	 * ******************* */
	/**
	 * Gnre la signature  envoyer  la plateforme  partir des champs enregistrs, la stocke
	 * dans $this->signature et la renvoie.
	 * @param $hashed boolean true par dfaut ; mettre  false pour obtenir la signature avant hachage
	 * @return string la signature calcule
	 */
	function generateRequestSignature($hashed=true)
	{
		$sign_content = "";
		foreach ($this->request_signature as $field)
		{
			$sign_content .= $this->$field;
			$sign_content .= "+";
		}
		$sign_content .= $this->get("key");
		$this->signature = $hashed ? sha1($sign_content) : $sign_content;
		return $this->signature;
	}
	
	/**
	 * Gnre la signature de la rponse  partir des champs enregistrs, la stocke
	 * dans $this->signature et la renvoie.
	 * @param $hashed boolean true par dfaut ; mettre  false pour obtenir la signature avant hachage
	 * @return string la signature calcule
	 */
	function generateResponseSignature($hashed=true)
	{
		$sign_content = "";
		foreach ($this->response_signature as $field)
		{
			$sign_content .= $this->$field;
			$sign_content .= "+";
		}
		$sign_content .= ($this->hash != '') ? $this->hash."+" : "";
//		$sign_content .= ($this->contrib=='VirtueMart1.1.4_2.6') ? '' : '+'.$this->get('contrib');
		$sign_content .= $this->get("key");
		$this->signature = $hashed ? sha1($sign_content) : $sign_content;
		return $this->signature;
	}
	
	
	/* ****************************************** *
	 * CONSTRUCTION DE LA REQUETE A LA PLATEFORME *
	 * ****************************************** */
	/**
	 * Renvoie true si tous les champs obligatoires de la requte ont t prpars, false sinon
	 * @return boolean
	 */
	function isRequestReady()
	{
		foreach ($this->getAttributeList("request_mandatory") as $field_name)
		{
			$value = $this->$field_name;
			if($value === null)
				return false;
		}
		return true;
	}
	 
	/**
	 * Renvoie le code html du formulaire utilis pour rediriger le client vers la plateforme de paiement
	 * @param $enteteMethod	POST ou GET ; utilisez de prfrence POST, sinon voir aussi getRequestUrlEncodedFields
	 * @param $enteteAdd attributs supplmentaires pour la balise <form>
	 * @param $inputType type des entres, hidden par dfaut
	 * @param $buttonValue texte du bouton
	 * @param $buttonAdd attributs supplmentaires du bouton
	 * @param $buttonType type du bouton, par dfaut submit
	 * @return string
	 */
	function getRequestHtmlForm($enteteAdd='',$inputType='hidden',
								$buttonValue='Aller sur la plateforme de paiement',$buttonAdd='',$buttonType='submit')
	{
		if(!$this->isRequestReady()) { return false; }
		
		$html  = "";
		$html .= '<form action="'.$this->platform_url.'" method="POST" '.$enteteAdd.'>';
		$html .= "\n";
		$html .= $this->getRequestHtmlInputs($inputType);
		$html .= '<input type="'.$buttonType.'" value="'.$buttonValue.'" '.$buttonAdd.'/>';
		$html .= "\n";
		$html .= '</form>';
		return $html;
	}
	
	/**
	 * Renvoie le code html des inputs du formulaire de redirection vers la plateforme
	 * @param $inputType par dfaut hidden
	 * @return string
	 */
	function getRequestHtmlInputs($inputType='hidden')
	{
		if(!$this->isRequestReady()) { return false; }
		
		$html = "";
		foreach ($this->getAttributeList("request_mandatory") as $field_name)
		{
			$value = $this->$field_name;
			$html .= '<input type="'.$inputType.'" name="'.$field_name.'" value="'.$value.'" />';
			$html .= "\n";
		}
		foreach ($this->getAttributeList("request_optionnal") as $field_name)
		{
			if( substr($field_name,0,8) == 'redirect' && !$this->isRedirectEnabled() )
			{
				continue;
			}
			$value = $this->$field_name;
			if($value !== null)
			{
				$html .= '<input type="'.$inputType.'" name="'.$field_name.'" value="'.$value.'" />';
				$html .= "\n";
			}
		}
		$sign = $this->generateRequestSignature();
		$html .= '<input type="'.$inputType.'" name="signature" value="'.$sign.'" />';
		$html .= "\n";
		return $html;
	}
	
	/**
	 * Renvoie l'url de la plateforme avec les paramtres  transmettre encods (mthode GET)
	 * Utiliser de prfrence un formulaire POST (url plus propre, pas de limite  la longueur des paramtres),
	 * cf. getRequestHtmlForm
	 * @return unknown_type
	 */
	function getRequestUrl()
	{
		if(!$this->isRequestReady()) { return false; }
		
		return $this->platform_url . '?' . $this->getRequestUrlEncodedFields();
	}
	
	/**
	 * Renvoie les paramtres url encods  transmettre lors de la redirection vers la plateforme,
	 * si vous utilisez un lien plutt qu'un formulaire.
	 * Utilisez de prfrence un formulaire POST (url plus propre, pas de limite  la longueur de paramtres) ou
	 * vitez d'utiliser les paramtres optionnels trop longs
	 * @return string ex : amount=1000&order_id=123&order_info=10%20euros%20%E0%20payer&...
	 */
	function getRequestUrlEncodedFields()
	{
		if(!$this->isRequestReady()) { return false; }
		
		$fields = "";
		foreach ($this->getAttributeList("request_mandatory") as $field_name)
		{
			$value = $this->$field_name;
			$fields .= $field_name."=".rawurlencode($value);
			$fields .= "&";
		}
		foreach ($this->getAttributeList("request_optionnal") as $field_name)
		{
			if( substr($field_name,0,8) == 'redirect' && !$this->isRedirectEnabled() )
			{
				continue;
			}
			$value = $this->$field_name;
			if($value !== null)
			{
				$fields .= $field_name."=".rawurlencode($value);
				$fields .= "&";
			}
		}
		$sign  = $this->generateRequestSignature();
		$fields .= "signature=$sign";
		return $fields;
	}
	
	/**
	 * return whether the automatic redirection is enabled or not
	 * (true if redirect_enabled = true or c.i. "true")
	 * @return boolean
	 */
	function isRedirectEnabled()
	{
		// accept true, 1, '1', "True"(ci)
		return (strval($this->redirect_enabled) === "1"
			|| strtolower($this->redirect_enabled) === "true");
	}
	
	/**
	 * Gnration d'un trans_id unique pour la transaction de ce site pour la journe
	 * Le renvoie et le stocke dans $this->trans_id
	 * @return string
	 */
	function generateTrans_id()
	{
		/*
		 * On utilise le nombre de diximes de seconde depuis minuit, qui respecte la spc :
		 * - 6 chiffres
		 * - de 000000  864000, donc infrieur  899999
		 * - unique sur une journe (sauf si 2 clients paient  moins de 0.1 seconde d'intervalle)
		 */
		list($usec, $sec) = explode(" ", microtime());	// microsecondes, compatible php4
		$temp = ($this->timestamp + $usec - strtotime('today 00:00')) * 10;
		$temp = sprintf('%06d',$temp);
		
		$this->trans_id = $temp;
		return $this->trans_id;
	}
	
	/**
	 * Renvoie et stocke dans $this->trans_date la date au format AAAAMMJJHHmmSS
	 * @return string
	 */
	function getTrans_date(){
		$temp = gmdate('YmdHis',$this->timestamp);

		$this->trans_date=$temp;
		return $this->trans_date;
	}
	
	
	/* ********************************** *
	 * ANALYSE DE LA REPONSE DE LA BANQUE *
	 * ********************************** */
	/**
	 * Set the response-related attributes from given tab ($_REQUEST by default)
	 * @param $tab
	 */
	function setResponseFromPost($tab=null, $key_test=null, $key_prod=null, $ctx_mode=null)
	{
		$tab = isset($tab) ? $tab : $_REQUEST;
		foreach ( $this->getAttributeList("response_all") as $field_name )
		{
			$this->$field_name = isset($tab[$field_name]) ? $tab[$field_name] : null;
		}
		if (isset($key_test)) {$this->key_test = $key_test;}
		if (isset($key_prod)) {$this->key_prod = $key_prod;}
		if (isset($ctx_mode)) {$this->ctx_mode = $ctx_mode;}
		$this->hash = isset($tab['hash']) ? $tab['hash'] : null;
		$this->received_signature = isset($tab['signature']) ? $tab['signature'] : null;
	}
	
	/**
	 * Compare la signature soumise avec celle calcule  partir des champs
	 * @param string $post_signature
	 * @return boolean true si les deux signatures sont identiques
	 */
	function isAuthentifiedResponse()
	{
		return ($this->generateResponseSignature() == $this->received_signature);
	}
	
	/**
	 * Renvoie true si le code retour enregistr correspond  un paiement russi, false sinon
	 * @return boolean
	 */
	function isAcceptedPayment()
	{
		return ($this->result == '00');
	}
	
	/**
	 * Renvoie true si le code retour enregistr correspond  une annulation client, false sinon
	 * @return boolean
	 */
	function isCancelledPayment()
	{
		return ($this->result == '17');
	}
	
	/**
	 * Renvoie, selon le paramtre type, le code retour de la rponse de la banque ou sa traduction
	 * @param $type 'detail' : renvoie le message et les dtails ventuels ; 'id' : renvoie le code retour ; sinon juste le message
	 * @return string
	 */
	function getResponseMessage($type='',$lang='fr'){
		// on demande le code...
		if($type == 'id')
			return $this->result;
		
		// ...ou sa traduction ?
		$this->loadResponsesTranslation($lang);
		$return = $this->tab_result[$this->result];
		if( $type == 'detail' && $this->result=='30')
		{
			// avec des dtails le cas chant
			$return .= $this->tab_extra_result[$this->extra_result];
		}

		return $return;
	}
	
	/**
	 * Renvoie la traduction du code retour 3D secure
	 * @return string
	 */
	function getReponse3DSec($lang='fr'){
		$this->loadResponsesTranslation($lang);
		$return = '';
		if($this->warranty_result!=''){
			$return .= $this->tab_warranty_result[$this->warranty_result];
		}

		return $return;
	}
	
	/* ********************************** *
	 * REPONSE A L'APPEL DE L'URL SERVEUR *
	 * ********************************** */
	/**
	 * Renvoie une rponse interprtable par la plateforme dans le cadre de l'appel de l'url serveur
	 * @param $success vrai pour donner une rponse positive  la plateforme, faux sinon ; si null, on utilise la mthode isAuthentifiedResponse
	 * @param $message informations complmentaires sur le rsultat du traitement de l'appel serveur
	 * @return string
	 */
	function getCheckUrlResponse($code='', $extra_msg="")
	{
		$success = false;
		$message  = '';
		
		// Messages prdfinis selon le cas
		$cases = array(
			'payment_ok' 				=> array(true,'Paiement valide trait'),
			'payment_ko' 				=> array(true,'Paiement invalide trait'),
			'payment_ok_already_done' 	=> array(true,'Paiement valide trait, dj enregistr'),
			'order_not_found' 			=> array(false,'Impossible de retrouver la commande'),
			'payment_ko_on_order_ok' 	=> array(false,'Code paiement invalide reu pour une commande dj valide'),
			'auth_fail' 				=> array(false,'Echec authentification'),
			'ok' 						=> array(true,''),
			'ko' 						=> array(false,'')
		);
		
		if(array_key_exists($code,$cases))
		{
			$success = $cases[$code][0];
			$message = $cases[$code][1];
		}
		
		$message .= ' '.$extra_msg;
		$message = str_replace("\n",'',$message);
		
		$response  = "";
		$response = '<span style="display:none">';
		$response .= $success ? "OK-" : "KO-";
		$response .= $this->get('hash');
		$response .= ($message===' ') ? "\n" : "=$message\n";
		$response .= '</span>';
		return $response;
	}
}

?>